<?php
declare(strict_types=1);

namespace FiloBlu\Maintenance\Block;

use FiloBlu\Maintenance\Helper\Data;
use Magento\Framework\Exception\NoSuchEntityException;
use Magento\Framework\UrlInterface;
use Magento\Framework\View\Element\Template;
use Magento\Framework\View\Element\Template\Context;

/**
 *
 */
class Maintenance extends Template
{

    /**
     * @var Data
     */
    public $_helper;
    protected $storeMaganer;

    /**
     * @param Context $context
     * @param Data $helper
     * @param array $data
     */
    public function __construct(
        Context $context,
        Data    $helper,
        array   $data = []
    )
    {
        $this->_helper = $helper;
        $this->storeManager = $context->getStoreManager();

        parent::__construct($context, $data);
    }

    /**
     * @return string
     * @throws NoSuchEntityException
     */
    public function getImageUrl()
    {
        if ($this->_helper->getConfig("general/bg_image")) {
            return $this->_storeManager->getStore()->getBaseUrl(UrlInterface::URL_TYPE_MEDIA) . "filoblu/maintenance/" . $this->_helper->getConfig("general/bg_image");
        } else {
            return "";
        }
    }

    /**
     * @return string
     * @throws NoSuchEntityException
     */
    public function getImageMobileUrl()
    {
        if ($this->_helper->getConfig("general/bg_image_mobile")) {
            return $this->_storeManager->getStore()->getBaseUrl(UrlInterface::URL_TYPE_MEDIA) . "filoblu/maintenance/" . $this->_helper->getConfig("general/bg_image_mobile");
        } else {
            return "";
        }
    }

    /**
     * @return mixed
     */
    public function getText()
    {
        return $this->_helper->getConfig("general/front_text");
    }

//    public function getLandingPage() {
//
//        if (!$this->getLandingPageEntity()) {
//            $this->setLandingPageEntity($this->_coreRegistry->registry('newsletter_landingpage_entity'));
//        }
//
//        return $this->getLandingPageEntity()->getData();
//    }
//
//    public function getImageUrl($image) {
//        return $this->_storeManager->getStore()->getBaseUrl(\Magento\Framework\UrlInterface::URL_TYPE_MEDIA) . "filoblu/newsletter/landingpage/image" . $image;
//    }
//
//    protected function _toHtml() {
//
//        if (!$this->_helper->getConfig("general/enabled")) {
//            return "";
//        } else {
//            $landing = $this->getLandingPage();
//
//            $this->setTemplate('FiloBlu_Newsletter::landingpage/landing_page_' . $landing["code"] . '.phtml');
//
//            if (!$this->getTemplateFile()) {
//
//                $this->setTemplate('FiloBlu_Newsletter::landingpage/landing_page.phtml');
//            }
//
//            return parent::_toHtml();
//        }
//    }
}
